;############################################################################
;        Trium,  ,  
;  ,  ,   .
;  ,     ,   ,
;    180 .        .
;############################################################################
#define LCD_DC		PORTC,3			;  1 /  
#define	LCD_RST		PORTC,4 		;  C3    
#define	LCD_CS		PORTC,5			;  C5   
#define	LCD_DATA	PORTC,6 		;  C4    
#define	LCD_CLK		PORTC,7			;  C0  CLK  
;
LCD_init:							;  	
;			bcf		LCD_CS			; CS = 0
			bcf		LCD_RST			;    RST   
			call	DELAY_25mS		; 
			bsf		LCD_RST			; RST=1	
			call	DELAY_25mS		;	
			bcf		LCD_DC			;  
			movlw	0x21			;   =1
			call	OUT_SPI
			movlw	0xcf			;
			call	OUT_SPI
 			movlw	0x06			; 
			call	OUT_SPI
			movlw	0x15			;  (0x10- -0x15) 
			call	OUT_SPI
			movlw	0x20			;   H=0
			call	OUT_SPI
			movlw	0x0c			; .   D=1 E=0 
			call	OUT_SPI			; (&h0d-  )
			movlw	0x1b			;   lcd trium aria  dont touch
			call	OUT_SPI
			call	DELAY_25mS		;
			bsf		LCD_DC			;    
			return
;___________________________________________________________________
OUT_SPI:							;    SPI ()
 			movwf	TX_DATA			;    
;			bcf		LCD_CS			; CS = 0 (   )
			movlw	.8
			movwf	COUNTER			;   8  
L_SPI:		rlf		TX_DATA, F		;   8  
 			btfss	STATUS, C		; ,    
			goto	$+3
			bsf		LCD_DATA		; LCD_DATA = 1
			goto	STROB
			bcf		LCD_DATA		;   0
STROB:		nop
			nop
			nop
			bsf		LCD_CLK			; CLK = 1  
			nop
			nop
			nop
			bcf		LCD_CLK			; CLK = 0
			decfsz	COUNTER, F		; ,   
			goto	L_SPI			;  
 			btfsc	LCD_DC			; ,   	
			incf	POZ_X, F		;      
;			bsf		LCD_CS			; CS = 1
			return
;___________________________________________________________________
CLR_STR_END:						;   . 
			clrw					;   
			call	OUT_SPI			;
			movlw	.96				;    .
			subwf	POZ_X, W		;    .
 			btfss	STATUS, Z		; ,   
			Goto	CLR_STR_END		;   
			return
;_________________
CLR_LCD:	movlw	.4				;    .
			MOVWF	POZ_Y			;   .
			movlw	.250			;    4   250
 			movwf	TEMP0			;   W  (  9*96=864/4=216 )
			clrw					;
			call	OUT_SPI			;
			decfsz	TEMP0, F		; ,  TEMP0 = 0
			goto	$-3				;   
			decfsz 	POZ_Y, F		;   ,  
			goto	$-7				;    ( =0)
			clrf	POZ_X			;  POZ_X   
;___________________________________________________________________
UST_POZ_XY:							;      .
			bcf		LCD_DC			;  
			movf	POZ_Y, W		;  Y	
			andlw	B'00000111'		;    Y
			sublw	.7				;    7 ( )
			addlw	0x40			; +    Y 
			call	OUT_SPI			;    . = 0...7
			movf	POZ_X, W		;  
			andlw	B'01111111'		;    (  )
			addlw	B'10000000'		; +    
			call	OUT_SPI			; 
			bsf		LCD_DC			; 	
			return
