;############################################################################
;        Trium
;        
;############################################################################
#define LCD_DC		PORTC,1			;  1 /  
#define	LCD_CLK		PORTC,0			;  C0  CLK  
#define	LCD_DATA	PORTC,4 		;  C4    
#define	LCD_CS		PORTC,5			;  C5   
#define	LCD_RST		PORTC,3 		;  C3    
;
LCD_initial:						;  	
			bcf		LCD_CS			; CS -> 0
			bcf		LCD_RST			;    RST   
			call	DELAY_25mS		; 
			bsf		LCD_RST			; RST=1	
			call	DELAY_25mS		;	
			bcf		LCD_DC			;  
;			movlw	0xE2			; Internal reset
;			call	OUT_SPI
;			call	DELAY_25mS		;
			movlw	0x21			;   =1
			call	OUT_SPI
			movlw	0xCF			;
			call	OUT_SPI
			movlw	0x06			; 
			call	OUT_SPI
			movlw	0x14			;  (0x10- -0x15) 
			call	OUT_SPI
			movlw	0x20			;   H=0
			call	OUT_SPI
			movlw	0x0C			;    D=1 E=0 (&h0d-  )
			call	OUT_SPI
			movlw	0x19			;   lcd trium aria  dont touch
			call	OUT_SPI
;			movlw	0xA1			;  LSB -> MSB     
;			call	OUT_SPI
;			movlw	0xAC			; 
;			call	OUT_SPI
;			movlw	0x07			; 
;			call	OUT_SPI
;			movlw	0xA6			;   (0xA7 ) 
;			call	OUT_SPI
;			movlw	0xAF			;   
;			call	OUT_SPI
			call	DELAY_25mS		;
			bsf		LCD_DC			;  
			return
;___________________________________________________________________
OUT_SPI:							;    SPI ()
 			movwf	TX_DATA			;    
			btfsc	INVERS_ON		; ,   
			comf	TX_DATA, F
			bcf		LCD_CS			; CS -> 0
			movlw	.8
			movwf	COUNTER			;   8 
			bcf		STATUS, C		;  (D/C) ()
 ;			btfsc	LCD_DC			; ,    
;			bsf		STATUS, C		;   (D/C) ()
;			goto	$+3							
L_SPI:		bcf		LCD_DATA		; LCD_DATA -> 0
			rlf		TX_DATA, F		;   8  (9 )
 			btfss	STATUS, C		; ,   
			goto	STROB			;  0
			bsf		LCD_DATA		;  1
STROB:		nop
			nop
			bsf		LCD_CLK			; CLK -> 1  
			nop
			nop
			nop
			bcf		LCD_CLK			; CLK -> 0
			decfsz	COUNTER, F		; ,   
			goto	L_SPI			;  
 			btfsc	LCD_DC			; ,    	
			incf	POZ_X, F		;     
			bsf		LCD_CS			; CS -> 1
			bcf		LCD_DATA		;
			return
;___________________________________________________________________
POZ_XY:								;   
			bcf		LCD_DC			;  

;			andlw	B'00001111'		;    Y
;			addlw	B'10110000'		; +    Y
;			call	OUT_SPI			;    . = 0...8
;			swapf	POZ_X, W		;    
;			andlw	B'00000111'		;    
;			addlw	B'00010000'		; +    
;			call	OUT_SPI			; Cod=00010XXX
;			movf	POZ_X, W		;    
;			andlw	B'00001111'		;    
;			call	OUT_SPI			; Cod=0000XXX

			clrw					;
			call	OUT_SPI			;
			movf	POZ_Y, W		;  Y			
			andlw	B'00000111'		;    Y
			addlw	0x40			; +    Y 
			call	OUT_SPI			;    . = 0...7
			movf	POZ_X, W		;  
			andlw	B'01111111'		;    
			addlw	B'10000000'		; +    
			call	OUT_SPI			; 
			bsf		LCD_DC			; 	
			return
;___________________________________________________________________
CLR_LCD:							;    
			movlw	.9
			movwf	TEMP2
			call	CLR_STR_END		; 9*96=864
			decfsz	TEMP2, F
			Goto	$-2
			return
CLR_STR_END:						;    . 
			movlw	.96		
			goto	PROBEL_W		;   W 
;___________________________________________________________________
DIG_OUT_0_000: 						;     0,000
			movf	RESULT3, W		; 
			call	PRINT_DIG		;
			movlw	'.'
			call	PRINT_SIMW		;  
DIG_OUT_000:
			movf	RESULT2, W		; 
			call	PRINT_DIG		;
DIG_OUT_00:
			movf	RESULT1, W		; 
			call	PRINT_DIG		;
			movf	RESULT0, W		; 
			call	PRINT_DIG		;
			return	

;############################################################################
;			     
;############################################################################
PROBEL_6:	movlw	.6				;   6 
			goto	PROBEL_W		;
PROBEL_5:	movlw	.5				;   5 
			goto	PROBEL_W		;
PROBEL_4:	movlw	.4				;   4 
			goto	PROBEL_W		;
PROBEL_3:	movlw	.3				;   3 
PROBEL_W:	movwf	TEMP0			;   W 
			clrw					;
			call	OUT_SPI			;
			decfsz	TEMP0, F		; ,  TEMP0 = 0
			goto	$-3				;   
			return
;__________________________
TXT_PRINT:							;     ( 0 )
			MOVLW	low (TXT_COD)	;  .      .		 
			ADDWF	LOC_SIMVOL, W	;    .  (  )
			MOVWF	TEMP0			;  
			MOVLW	high (TXT_COD)
			BTFSC	STATUS, C		;        255 
			ADDLW	0x1				;   W  1
			MOVWF	PCLATH			;  PCLATH
			MOVF	TEMP0, W		;       .
			CALL	TXT_COD			;      
			ADDLW	0x00			;   
			BTFSC	STATUS, Z		; ,    
			RETURN					;      
;			MOVLW	high $
;			MOVWF	PCLATH			;  PCLATH
			call	PRINT_SIMW		;    . 
			incf 	LOC_SIMVOL, F	;  
			GOTO	TXT_PRINT		;      
;____________________________________
;   7x5          X Y 
PRINT_DIG:	addlw	0x30			;        
PRINT_SIMW:	movwf	TEMP0			;    
			movlw	.5				;     
			movwf	LONG_X			;    
TRNCM_LOC3	movlw	0x20			; (   )
			subwf	TEMP0, W		;     
			movwf	TEMP0			;     5
			clrf	TEMP1			;
			bcf		STATUS, C		;
			rlf		TEMP0, F		;
			rlf		TEMP1, F		;
			rlf		TEMP0, F		;
			rlf		TEMP1, F		;
			addwf	TEMP0, W		;   .    
			btfsc	STATUS, C		; ,   
			incf	TEMP1, F		;   .    
			banksel	EEADR			;  2
			movwf	EEADR			;  .    .   FLASH
			clrf	STATUS			;  0
			movlw	high (TABLE)	; 
			addwf	TEMP1, W		;   .  
			banksel	EEADR			;  2
			movwf	EEADRH			;  .  
			call	READ_FLASH		;       
			call	OUT_SPI			;    ( )
			decf	LONG_X, F		;
TRNCM_LOC1	call	READ_FLASH		;       
			addlw	.0				;   
			btfsc	STATUS, Z		; ,   			
			goto	TRNCM_LOC2		;   
			call	OUT_SPI			;   
			decfsz	LONG_X, F		; ,   
			goto	TRNCM_LOC1		;    
			clrw					;
TRNCM_LOC2	call	OUT_SPI			;      
			return
;____________________________________
PRINT_SIMWx2:						;    

PRINT_DIGx2:						;    
			call	DECOD_ADR		;  .    
			banksel	EEADR			;  2
			movwf	EEADR			;  .    .   FLASH
			movlw	high (TABLE2x2)
			movwf	EEADRH			;  .  
			call	READ_FLASH		;     -2
			bcf		Simw_cod2		;    2  
			movwf	LONG_X
Tx_Lop3:	movf	LONG_X, W		; LONG_X    + 2 
			movwf	TEMP0
Tx_Lop2:	call	READ_FLASH		;      -2
			call	OUT_SPI			;   
			decfsz	TEMP0, F		;       
			goto	Tx_Lop2
			clrw					;    2   	
			call	OUT_SPI			;
			clrw					;
			call	OUT_SPI			;
			btfsc	Simw_cod2		; ,    2-  
			goto	Tx_Loc4			;   
			bsf		Simw_cod2		;    2-   
			movf	LONG_X, W		;        
			addlw	.2				;
			subwf	POZ_X, F		;  LONG_X   
			decf	POZ_Y, W
			call	POZ_XY			;       
			goto	Tx_Lop3			;   
Tx_Loc4:	movf	POZ_Y, W		;      
			call	POZ_XY			;      
			return
;____________________________________
READ_FLASH:							;    
			banksel	EECON1			;  3
			bsf		EECON1, EEPGD	;   FLASH 
			bsf		EECON1, RD		; 
			nop						; 2  
			nop						;
			banksel	EEDATA			;  2
			incf	EEADR, F		;   1  
			btfsc	STATUS, Z		;    
			incf	EEADRH, F		;   1 .  
			movf	EEDATA, W		;    (.  )
			clrf	STATUS			;  0
			return